--
-- select tasks by query params
--
SELECT
    T.ID AS TASK_ID
   ,T.TITLE
   ,T.START_DATE
   ,T.START_YEAR
   ,T.START_MONTH
   ,T.START_DAY_OF_MONTH
   ,T.DEAD_LINE
   ,T.DEAD_LINE_YEAR
   ,T.DEAD_LINE_MONTH
   ,T.DEAD_LINE_DAY_OF_MONTH
   ,T.PRIORITY_ORDER
   ,R.ACTIVITY_ID      AS ACTIVITY_ID
   ,V.NAME             AS ACTIVITY_VALUE
   ,R.STATUS_ID
   ,R.CLASSIFICATION_ID
   ,C.TYPE             AS CLASSIFICATION_TYPE
   ,C.VALUE            AS CLASSIFICATION_VALUE
   ,O.COLOR            AS COLOR_VALUE
   ,R.PERSON_ID
   ,COALESCE(U1.LAST_NAME,'')  AS PERSON_LAST_NAME
   ,COALESCE(U1.FIRST_NAME,'') AS PERSON_FIRST_NAME
   ,R.POSTED_USER_ID
   ,U2.LAST_NAME
   ,U2.FIRST_NAME
   ,T.REGISTERED
/*IF selectedFolderId == 21*/
   ,TH.MODIFIED
/*END*/
   ,G.TAG_ID
   ,G.TAG_VALUE
   ,GR.TASK_GROUP_ID
   ,GR.TASK_GROUP_NAME
FROM
    task_relations R
    INNER JOIN tasks                   T  ON R.TASK_ID           = T.ID
/*IF selectedFolderId == 21*/
    INNER JOIN (
        SELECT
            MAX(H.REGISTERED) AS MODIFIED
           ,H.TASK_ID
        FROM
            task_histories H
        WHERE
            H.USER_ID = /*userId*/1
        AND H.STATUS_ID = 3
        GROUP BY
            H.TASK_ID
    ) TH ON R.TASK_ID = TH.TASK_ID
/*END*/
    INNER JOIN activities              V  ON R.ACTIVITY_ID       = V.ID
    INNER JOIN activity_members        Y  ON V.ID                = Y.ACTIVITY_ID
                                         AND Y.USER_ID           = /*userId*/1
    INNER JOIN classifications         C  ON R.CLASSIFICATION_ID = C.ID
    INNER JOIN activity_relations      I  ON R.ACTIVITY_ID       = I.ACTIVITY_ID
                                         AND I.USER_ID           = /*userId*/1
    INNER JOIN activity_colors         O  ON I.COLOR_ID          = O.ID
    LEFT JOIN (
        SELECT
            TR.TASK_GROUP_ID
           ,TG.NAME AS TASK_GROUP_NAME
           ,TR.TASK_ID
        FROM
            task_group_relations TR
            INNER JOIN task_groups TG           ON TR.TASK_GROUP_ID = TG.ID
                                               AND TG.DEL_FLAG      = '0'
    ) GR ON R.TASK_ID     = GR.TASK_ID
    LEFT  JOIN users                   U1 ON R.PERSON_ID         = U1.ID
    INNER JOIN users                   U2 ON R.POSTED_USER_ID    = U2.ID
    LEFT  JOIN (
        SELECT
            G.TASK_ID
           ,G.TAG_ID
           ,S.VALUE AS TAG_VALUE
        FROM
            task_tags G
            INNER JOIN tags S ON G.TAG_ID = S.ID
        WHERE
            G.USER_ID = /*userId*/1
    ) G ON R.TASK_ID = G.TASK_ID
WHERE
    R.TASK_ID IN /*taskIds*/(1,2,3)
ORDER BY
/*IF selectedFolderId >= 0 && selectedFolderId <= 5*/
    R.CLASSIFICATION_ID
   ,R.STATUS_ID
   ,T.DEAD_LINE
   ,R.ACTIVITY_ID
   ,T.REGISTERED DESC
/*END*/
/*IF selectedFolderId == 9*/
    R.CLASSIFICATION_ID
   ,T.REGISTERED DESC
   ,R.ID
/*END*/
/*IF selectedFolderId == 21*/
    TH.MODIFIED DESC
   ,R.ACTIVITY_ID
/*END*/
/*IF selectedFolderId == 99*/
    R.CLASSIFICATION_ID
   ,T.REGISTERED
/*END*/